package com.sf.day06.entend;

import javax.swing.*;

public class CreditCard extends DepositCard{

//  本月可透支总额度，本月已透支金额

    private  double totalMoney;  //可透支总额度
    private  double overMoney;   //已透支金额

    public CreditCard() {
    }

    public CreditCard(double totalMoney, double overMoney) {
        this.totalMoney = totalMoney;
        this.overMoney = overMoney;
    }


    public double getTotalMoney() {
        return totalMoney;
    }

    public void setTotalMoney(double totalMoney) {
        this.totalMoney = totalMoney;
    }

    public double getOverMoney() {
        return overMoney;
    }

    public void setOverMoney(double overMoney) {
        this.overMoney = overMoney;
    }

    @Override
    public String toString() {
        return "CreditCard{" +
                "totalMoney=" + totalMoney +
                ", overMoney=" + overMoney +
                '}';
    }


    /**
     * 取款金额超过账户余额+本月还可透支额度，提示超过可透支额度
     *   - 取款金额在账户余额范围内，不用透支
     *   - 取款金额超过账户余额但在可透支范围内，需要透支
     * @param money
     */
    @Override
    public void withdraw(double money) {
        if(money > getBalance()+totalMoney-overMoney){
            System.out.println("超过可透支额度~");
            return;
        }
        if(money <=getBalance()  ){
            super.withdraw(money);
            return;
        }
      overMoney  +=  money - getBalance();
        //   将余额清零
        setBalance(0.0);
    }

    /**
     * 存款金额不能为负数，否则提示存款金额不能为负数
     *   - 本次存款金额只够偿还部分已透支金额
     *   - 本次存款金额除了偿还透支金额，还有剩余
     * @param money
     */
    public void save(double money){
        if(money < 0){
            System.out.println("提示存款金额不能为负数");
            return;
        }

        if(money <= overMoney){
            overMoney -= money;
            return;
        }

        //  偿还完已透支  还有余额
        setBalance(getBalance() +(money - overMoney) );
        // 把透支清零
        overMoney = 0.0;
    }


    public static void main(String[] args) {
        DepositCard depositCard = new DepositCard();
        depositCard.setId("1");
        depositCard.setBalance(1000.0);

//        System.out.println(depositCard);
//        depositCard.withdraw(200);
//        depositCard.withdraw(900);
//        System.out.println(depositCard);

        CreditCard creditCard = new CreditCard();
        creditCard.setTotalMoney(500);
        creditCard.setBalance(1000.0);
        creditCard.withdraw(1400);
        System.out.println(creditCard);
    }



}
